diff -r 3f1e7d35d0ab -r 821e8eadeaff src/dep/servo.c
--- a/src/dep/servo.c	Tue May 14 17:07:59 2013 -0700
+++ b/src/dep/servo.c	Sun Oct 27 22:49:29 2013 -0700
@@ -1,4 +1,6 @@
 /*-
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
  * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
  *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen
  * Copyright (c) 2005-2008 Kendall Correll, Aidan Williams
@@ -69,8 +71,8 @@
 #if !defined(__APPLE__)
 
 	if (!rtOpts->noAdjust)
-		adjFreq(0);
-	ptpClock->observed_drift = 0;
+		adjTime(0, rtOpts->time_mode, ptpClock);
+	ptpClock->observed_drift = 0.0;
 #endif /* apple */
 
 
@@ -85,10 +87,8 @@
 
 	ptpClock->ofm_filt.y           = 0;
 	ptpClock->ofm_filt.nsec_prev   = -1; /* AKB: -1 used for non-valid nsec time */
-	ptpClock->ofm_filt.nsec_prev   = 0;
-
 	ptpClock->owd_filt.s_exp       = 0;  /* clears one-way delay filter */
-	rtOpts->offset_first_updated   = FALSE;
+	ptpClock->offset_first_updated   = FALSE;
 
 	ptpClock->char_last_msg='I';
 
@@ -105,6 +105,10 @@
 void 
 updateDelay(one_way_delay_filter * owd_filt, RunTimeOpts * rtOpts, PtpClock * ptpClock, TimeInternal * correctionField)
 {
+	/* updates paused, leap second pending - do nothing */
+        if(ptpClock->leapSecondInProgress)
+		return;
+
 	/* todo: do all intermediate calculations on temp vars */
 	TimeInternal prev_meanPathDelay = ptpClock->meanPathDelay;
 
@@ -121,31 +125,41 @@
 	/* calc 'slave_to_master_delay' */
 	subTime(&slave_to_master_delay, &ptpClock->delay_req_receive_time, 
 		&ptpClock->delay_req_send_time);
-
+/*
 	if (slave_to_master_delay.nanoseconds < 0) {
-		INFO("updateDelay aborted, delay %d is negative",
+		INFO("updateDelay aborted, delay %d is negative\n",
 		     slave_to_master_delay.nanoseconds);
 		return;
 	}
+*/
 
-	if (rtOpts->maxDelay) { /* If maxDelay is 0 then it's OFF */
-		if (slave_to_master_delay.seconds && rtOpts->maxDelay) {
+	/* If maxDelay is 0 then it's OFF */
+	if ((rtOpts->maxDelay.seconds || rtOpts->maxDelay.nanoseconds) &&
+	    ptpClock->offset_first_updated) {
+		if (slave_to_master_delay.seconds) {
 			INFO("updateDelay aborted, delay greater than 1"
-			     " second.");
+			     " second.\n");
 			msgDump(ptpClock);
 				goto display;
 		}
-
-		if (slave_to_master_delay.nanoseconds > rtOpts->maxDelay) {
-			INFO("updateDelay aborted, delay %d greater than "
-			     "administratively set maximum %d\n",
-			     slave_to_master_delay.nanoseconds, 
-			     rtOpts->maxDelay);
+		/* Get scalar versions of the the slave to master delay and
+		 * max delay */
+		int64_t s_to_m_delay = internalTime_to_scalar(&slave_to_master_delay);
+		int64_t max_delay = internalTime_to_scalar(&rtOpts->maxDelay);
+		
+		if ((s_to_m_delay > max_delay) ||
+		    (s_to_m_delay < -max_delay)) {
+			INFO("updateDelay aborted, s->m delay %d.%09d greater than "
+			     "administratively set maximum %d.%09d\n",
+			     slave_to_master_delay.seconds,
+			     slave_to_master_delay.nanoseconds,
+			     rtOpts->maxDelay.seconds,
+			     rtOpts->maxDelay.nanoseconds);
 			msgDump(ptpClock);
 				goto display;
-			}
 		}
 	}
+	}
 
 
 	/*
@@ -153,7 +167,7 @@
 	 *   - update the global delaySM variable
 	 *   - calculate a new filtered MPD
 	 */
-	if (rtOpts->offset_first_updated) {
+	if (ptpClock->offset_first_updated) {
 		Integer16 s;
 
 		/*
@@ -313,6 +327,12 @@
 updateOffset(TimeInternal * send_time, TimeInternal * recv_time,
     offset_from_master_filter * ofm_filt, RunTimeOpts * rtOpts, PtpClock * ptpClock, TimeInternal * correctionField)
 {
+	DBGV("UTCOffset: %d, %d | leap 59: %d |  leap61: %d\n", 
+	     ptpClock->currentUtcOffsetValid, ptpClock->currentUtcOffset,
+	     ptpClock->leap59, ptpClock->leap61);
+        /* updates paused, leap second pending - do nothing */
+        if(ptpClock->leapSecondInProgress)
+		return;
 
 	DBGV("==> updateOffset\n");
 
@@ -322,19 +342,24 @@
 	/* calc 'master_to_slave_delay' */
 	subTime(&master_to_slave_delay, recv_time, send_time);
 
-	if (rtOpts->maxDelay) { /* If maxDelay is 0 then it's OFF */
-		if (master_to_slave_delay.seconds && rtOpts->maxDelay) {
-			INFO("updateOffset aborted, delay greater than 1"
-			     " second.");
-			msgDump(ptpClock);
-			return;
-		}
 
-		if (master_to_slave_delay.nanoseconds > rtOpts->maxDelay) {
-			INFO("updateOffset aborted, delay %d greater than "
-			     "administratively set maximum %d\n",
-			     master_to_slave_delay.nanoseconds, 
-			     rtOpts->maxDelay);
+	
+	/* If maxDelay is 0 then it's OFF */
+	if ((rtOpts->maxDelay.seconds || rtOpts->maxDelay.nanoseconds) &&
+	    ptpClock->offset_first_updated) {
+		/* Get scalar versions of the the slave to master delay and
+		 * max delay */
+		int64_t m_to_s_delay = internalTime_to_scalar(&master_to_slave_delay);
+		int64_t max_delay = internalTime_to_scalar(&rtOpts->maxDelay);
+		
+		if ((m_to_s_delay > max_delay) ||
+		    (m_to_s_delay < -max_delay)) {
+			INFO("updateDelay aborted, m->s delay %d.%09d greater than "
+			     "administratively set maximum %d.%09d\n",
+			     master_to_slave_delay.seconds,
+			     master_to_slave_delay.nanoseconds,
+			     rtOpts->maxDelay.seconds,
+			     rtOpts->maxDelay.nanoseconds);
 			msgDump(ptpClock);
 			return;
 		}
@@ -344,6 +369,13 @@
 	ptpClock->char_last_msg='S';
 	ptpClock->last_packet_was_sync = TRUE;
 
+	DBGV("send_time = %d.%09d\n",
+	     send_time->seconds, send_time->nanoseconds);
+	DBGV("recv_time = %d.%09d\n",
+             recv_time->seconds, recv_time->nanoseconds);
+	DBGV("master_to_slave_delay = %d.%09d\n",
+	     master_to_slave_delay.seconds, master_to_slave_delay.nanoseconds);
+
 	/*
 	 * The packet has passed basic checks, so we'll:
 	 *   - update the global delayMS variable
@@ -355,14 +387,21 @@
 	/* Take care about correctionField */
 	subTime(&ptpClock->delayMS,
 		&ptpClock->delayMS, correctionField);
+	DBGV("delayMS = %d.%09d\n",
+	     ptpClock->delayMS.seconds, ptpClock->delayMS.nanoseconds);
+	DBGV("correctionField = %d.%09d\n",
+	     correctionField->seconds, correctionField->nanoseconds);
+	DBGV("meanPathDelay = %d.%09d\n",
+	     ptpClock->meanPathDelay.seconds, ptpClock->meanPathDelay.nanoseconds);
 
 
+	DBGV("updateOffset: delayMechanism = %d\n", ptpClock->delayMechanism);
 	/* update 'offsetFromMaster' */
 	if (ptpClock->delayMechanism == P2P) {
 		subTime(&ptpClock->offsetFromMaster, 
 			&ptpClock->delayMS, 
 			&ptpClock->peerMeanPathDelay);
-	} else if (ptpClock->delayMechanism == E2E) {
+	} else {
 		/* (End to End mode) */
 		subTime(&ptpClock->offsetFromMaster, 
 			&ptpClock->delayMS, 
@@ -372,13 +411,16 @@
 	if (ptpClock->offsetFromMaster.seconds) {
 		/* cannot filter with secs, clear filter */
 		ofm_filt->nsec_prev = 0;
-		rtOpts->offset_first_updated = TRUE;
+		ptpClock->offset_first_updated = TRUE;
 		return;
 	}
 
 	/* filter 'offsetFromMaster' */
-	ofm_filt->y = ptpClock->offsetFromMaster.nanoseconds / 2 + 
-		ofm_filt->nsec_prev / 2;
+	/* The time is normalised so the nanoseconds will be less than 10^9. Improve
+	 * accuracy of calculation by doing division after addition. Add 1 to get correct
+	 * rounding.
+	 */
+	ofm_filt->y = (ptpClock->offsetFromMaster.nanoseconds + ofm_filt->nsec_prev + 1) / 2;
 	ofm_filt->nsec_prev = ptpClock->offsetFromMaster.nanoseconds;
 	ptpClock->offsetFromMaster.nanoseconds = ofm_filt->y;
 
@@ -388,41 +430,44 @@
 	 * Offset must have been computed at least one time before 
 	 * computing end to end delay
 	 */
-		rtOpts->offset_first_updated = TRUE;
+		ptpClock->offset_first_updated = TRUE;
 	}
 
 
 
-void servo_perform_clock_step(RunTimeOpts * rtOpts, PtpClock * ptpClock)
+void servo_perform_clock_step(RunTimeOpts * rtOpts, PtpClock * ptpClock, TimeInternal *offset)
 {
 	if(rtOpts->noAdjust){
 		WARNING("     Clock step blocked because of option -t\n");
 		return;
 	}
 
-	TimeInternal timeTmp;
-	
-	getTime(&timeTmp);
-	subTime(&timeTmp, &timeTmp, &ptpClock->offsetFromMaster);
+	WARNING("performing hard frequency reset, by setting frequency to zero\n");
+	/* In our driver, stepping the time also has the effect of setting the frequency */
+	/* adjustment to zero. */
+	 adjTimeOffset(offset, rtOpts->time_mode, ptpClock);
+	ptpClock->observed_drift = 0.0;
 
-	WARNING("     Performing hard frequency reset, by setting frequency to zero\n");
-	adjFreq(0);
-	ptpClock->observed_drift = 0;
-
-	setTime(&timeTmp);
 	initClock(rtOpts, ptpClock);
-	toState(PTP_FAULTY, rtOpts, ptpClock);		/* make a full protocol reset */
 }
 
 
-void warn_operator_fast_slewing(RunTimeOpts * rtOpts, PtpClock * ptpClock, Integer32 adj)
+void warn_operator_fast_slewing(RunTimeOpts * rtOpts, PtpClock * ptpClock, LongDouble adj)
 {
-	if(ptpClock->warned_operator_fast_slewing == 0){
-		if ((adj >= ADJ_FREQ_MAX) || ((adj <= -ADJ_FREQ_MAX))){
+	LongDouble max_adj;
+	if ((rtOpts->time_mode == TIME_NIC) || (rtOpts->time_mode == TIME_BOTH))
+		max_adj = ADJ_FREQ_MAX_NIC;
+	else
+		max_adj = ADJ_FREQ_MAX_SYSTEM;
+	
+	if ((adj >= max_adj) || (adj <= -max_adj)) {
+		if(ptpClock->warned_operator_fast_slewing == 0) {
 			ptpClock->warned_operator_fast_slewing = 1;
 
 			NOTICE("Servo: Going to slew the clock with the maximum frequency adjustment\n");
 		}
+	} else {
+		ptpClock->warned_operator_fast_slewing = 0;
 	}
 
 }
@@ -436,9 +481,10 @@
 		/* rule of thumb: at tick rate 10000, slewing at the maximum speed took 0.5ms per second */
 		float estimated = (((abs(ptpClock->offsetFromMaster.seconds)) + 0.0) * 2.0 * 1000.0 / 3600.0);
 
-
-		ALERT("Servo: %d seconds offset detected, will take %.1f hours to slew\n",
+		// we don't want to arrive early 1s in an expiration opening, so all consoles get a message when the time is 1s off.
+		ALERT("Servo: %d.%09d seconds offset detected, will take %.1f hours to slew\n",
 			ptpClock->offsetFromMaster.seconds,
+			ptpClock->offsetFromMaster.nanoseconds,
 			estimated
 		);
 		
@@ -447,22 +493,25 @@
 
 
 /*
- * this is a wrapper around adjFreq to abstract extra operations
+ * this is a wrapper around adjTime to abstract extra operations
  */
-void adjFreq_wrapper(RunTimeOpts * rtOpts, PtpClock * ptpClock, Integer32 adj)
+void adjTime_wrapper(RunTimeOpts * rtOpts, PtpClock * ptpClock, LongDouble adj)
 {
 
 
    
 	if (rtOpts->noAdjust){
-		DBGV("adjFreq2: noAdjust on, returning\n");
+		DBGV("adjTime_wrapper: noAdjust on, returning\n");
 		return;
 	}
 
+	// go back to only sending delayreq after first sync
+	// otherwise we lose the first sync always
+	// test all combinations
 
 	// call original adjtime
-	DBG2("     adjFreq2: call adjfreq to %d us \n", adj / DBG_UNIT);
-	adjFreq(adj);
+	DBG2("     adjTime_wrapper: call adjTime to %d \n", adj);
+	adjTime(adj, rtOpts->time_mode, ptpClock);
 
 	warn_operator_fast_slewing(rtOpts, ptpClock, adj);
 
@@ -475,8 +524,11 @@
 void 
 updateClock(RunTimeOpts * rtOpts, PtpClock * ptpClock)
 {
-	Integer32 adj;
-	//TimeInternal timeTmp;
+    LongDouble adj;
+
+	/* updates paused, leap second pending - do nothing */
+        if(ptpClock->leapSecondInProgress)
+            return;
 
 	DBGV("==> updateClock\n");
 
@@ -514,26 +566,31 @@
 		/*
 		 * noAdjust     = cannot do any change to clock
 		 * noResetClock = if can change the clock, can we also step it?
+		 * resetClockOnlyOnce = can only step clock on first update
 		 */
 		if (!rtOpts->noAdjust) {
 			/* */
-			if (!rtOpts->noResetClock) {
+			if (!rtOpts->noResetClock &&
+			    (!rtOpts->resetClockStartupOnly || !ptpClock->clock_first_updated)) {
 
-				servo_perform_clock_step(rtOpts, ptpClock);
+				servo_perform_clock_step(rtOpts, ptpClock, &ptpClock->offsetFromMaster);
 			} else {
 				/*
 				 * potential problem:    "-1.1" is   a) -1:0.1 or b) -1:-0.1?
 				 * if this code is right it implies the second case
 				 */
 #if !defined(__APPLE__)
-				adj = ptpClock->offsetFromMaster.nanoseconds
-					> 0 ? ADJ_FREQ_MAX : -ADJ_FREQ_MAX;
-
-				// does this hurt when the clock gets close to zero again?
-				ptpClock->observed_drift = adj;
+				LongDouble max_adj;
+				if ((rtOpts->time_mode == TIME_NIC) || (rtOpts->time_mode == TIME_BOTH))
+					max_adj = ADJ_FREQ_MAX_NIC;
+				else
+					max_adj = ADJ_FREQ_MAX_SYSTEM;
+				
+				adj = (ptpClock->offsetFromMaster.nanoseconds > 0.0)?
+					max_adj : -max_adj;
 
 				warn_operator_slow_slewing(rtOpts, ptpClock);
-				adjFreq_wrapper(rtOpts, ptpClock, -adj);
+				adjTime_wrapper(rtOpts, ptpClock, -adj);
 
 				/* its not clear how the APPLE case works for large jumps */
 #endif /* __APPLE__ */
@@ -541,14 +598,18 @@
 			}
 		}
 	} else {
+		LongDouble max_adj;
 		/* these variables contain the actual ai and ap to be used below */
 		Integer32 ap = rtOpts->ap;
 		Integer32 ai = rtOpts->ai;
 
+		/* Clear the slow slewing warning so that it will be re-issued if
+		 * another large offset occurs */
+		ptpClock->warned_operator_slow_slewing = 0;
+	
 
 		
 
-		
 		/* the PI controller */
 		/* Offset from master is less than one second.  Use the the PI controller
 		 * to adjust the time
@@ -561,44 +622,48 @@
 			ai = 1;
 
 
+		/*
+		 *  optional new PI controller, with better accuracy with HW-timestamps:
+		 *  http://sourceforge.net/tracker/?func=detail&aid=2995791&group_id=139814&atid=744632
+		 */
 
 		
 		/* the accumulator for the I component */
 		// original PI servo
 		ptpClock->observed_drift += 
-			ptpClock->offsetFromMaster.nanoseconds / ai;
+			(LongDouble)ptpClock->offsetFromMaster.nanoseconds / (LongDouble)ai;
 
-		// ADJ_FREQ_MAX: 512 000
+		if ((rtOpts->time_mode == TIME_NIC) || (rtOpts->time_mode == TIME_BOTH))
+			max_adj = ADJ_FREQ_MAX_NIC;
+		else
+			max_adj = ADJ_FREQ_MAX_SYSTEM;
+		
+		/* clamp the accumulator to ADJ_FREQ_MAX for sanity */
+		if (ptpClock->observed_drift > max_adj)
+			ptpClock->observed_drift = max_adj;
+		else if (ptpClock->observed_drift < -max_adj)
+			ptpClock->observed_drift = -max_adj;
 
-		/* clamp the accumulator to ADJ_FREQ_MAX for sanity */
-		if (ptpClock->observed_drift > ADJ_FREQ_MAX)
-			ptpClock->observed_drift = ADJ_FREQ_MAX;
-		else if (ptpClock->observed_drift < -ADJ_FREQ_MAX)
-			ptpClock->observed_drift = -ADJ_FREQ_MAX;
-
-		adj = ptpClock->offsetFromMaster.nanoseconds / ap +
+		adj = (LongDouble)ptpClock->offsetFromMaster.nanoseconds / (LongDouble)ap +
 			ptpClock->observed_drift;
 
-		DBG("     Observed_drift with AI component: %d\n",
-			ptpClock->observed_drift  );
+		DBG("     Observed_drift with AI component: %Lf\n",
+			 ptpClock->observed_drift);
 
-		DBG("     After PI: Adj: %d   Drift: %d   OFM %d\n",
+		DBG("     After PI: Adj: %Lf   Drift: %Lf   OFM %d\n",
 			adj, ptpClock->observed_drift , ptpClock->offsetFromMaster.nanoseconds);
 
-
-		DBG2("     Observed_drift with AI component: %d\n",
-			ptpClock->observed_drift / DBG_UNIT );
-
-		DBG2("     After PI: Adj: %d   Drift: %d   OFM %d\n",
-			adj, ptpClock->observed_drift / DBG_UNIT, ptpClock->offsetFromMaster.nanoseconds / DBG_UNIT);
-
 #if defined(__APPLE__)
-			adjTime(ptpClock->offsetFromMaster.nanoseconds);
+			adjTime((LongDouble)ptpClock->offsetFromMaster.nanoseconds);
 #else
-		adjFreq_wrapper(rtOpts, ptpClock, -adj);
+		adjTime_wrapper(rtOpts, ptpClock, -adj);
 #endif /* __APPLE__ */
 	}
 
+	/* If we get here, the clock has been updated. Used to enable syncing of
+	 * second servo in time both mode.
+	 */
+	ptpClock->clock_first_updated = TRUE;
 
 
 display:
@@ -625,6 +690,6 @@
 	DBGV("offset from master:      %10ds %11dns\n",
 	    ptpClock->offsetFromMaster.seconds, 
 	    ptpClock->offsetFromMaster.nanoseconds);
-	DBGV("observed drift:          %10d\n", ptpClock->observed_drift);
+	DBGV("observed drift:          %Lf\n", ptpClock->observed_drift);
 }
 
diff -r 3f1e7d35d0ab -r 821e8eadeaff src/dep/sfxge_ioctl.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/dep/sfxge_ioctl.h	Sun Oct 27 22:49:29 2013 -0700
@@ -0,0 +1,135 @@
+/*
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ */
+/****************************************************************************
+ * Driver for Solarflare network controllers
+ *           (including support for SFE4001 10GBT NIC)
+ *
+ * Copyright 2005-2006: Fen Systems Ltd.
+ * Copyright 2006-2010: Solarflare Communications Inc,
+ *                      9501 Jeronimo Road, Suite 250,
+ *                      Irvine, CA 92618, USA
+ *
+ * Initially developed by Michael Brown <mbrown@fensystems.co.uk>
+ * Maintained by Solarflare Communications <linux-net-drivers@solarflare.com>
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 as published
+ * by the Free Software Foundation, incorporated herein by reference.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ ****************************************************************************
+ */
+
+#ifndef SFXGE_IOCTL_H
+#define SFXGE_IOCTL_H
+
+#include <sys/sockio.h>
+#define __u8	uint8_t
+#define __u16   uint16_t
+#define __u32   uint32_t
+#define __u64   uint64_t
+#define __s8	int8_t
+#define __s16	int16_t
+#define __s32	int32_t
+#define __s64	int64_t
+
+#define SFXGE_IOC	('S' << 24 | 'F' << 16 | 'C' << 8)
+
+#define SFXGE_TS_INIT		(SFXGE_IOC | 0x12)
+#define SFXGE_TS_READ		(SFXGE_IOC | 0x13)
+#define SFXGE_TS_SETTIME	(SFXGE_IOC | 0x14)
+#define SFXGE_TS_ADJTIME	(SFXGE_IOC | 0x15)
+#define SFXGE_TS_SYNC		(SFXGE_IOC | 0x16)
+
+#define	SFXGE_DRV_VERSION1	1
+
+/* PTP support for NIC time disciplining ************************************/
+
+struct sfxge_timespec {
+	int64_t tv_sec;
+	int32_t	tv_nsec;
+};
+
+/* Initialise timestamping, like SIOCHWTSTAMP *******************************/
+
+enum {
+      	HWTSTAMP_TX_OFF,
+	HWTSTAMP_TX_ON,
+};
+
+enum {
+      	HWTSTAMP_FILTER_NONE,
+	HWTSTAMP_FILTER_ALL,
+	HWTSTAMP_FILTER_SOME,
+	HWTSTAMP_FILTER_PTP_V1_L4_EVENT,
+	HWTSTAMP_FILTER_PTP_V1_L4_SYNC,
+	HWTSTAMP_FILTER_PTP_V1_L4_DELAY_REQ,
+	HWTSTAMP_FILTER_PTP_V2_L4_EVENT,
+	HWTSTAMP_FILTER_PTP_V2_L4_SYNC,
+	HWTSTAMP_FILTER_PTP_V2_L4_DELAY_REQ,
+	HWTSTAMP_FILTER_PTP_V2_L2_EVENT,
+	HWTSTAMP_FILTER_PTP_V2_L2_SYNC,
+	HWTSTAMP_FILTER_PTP_V2_L2_DELAY_REQ,
+	HWTSTAMP_FILTER_PTP_V2_EVENT,
+	HWTSTAMP_FILTER_PTP_V2_SYNC,
+	HWTSTAMP_FILTER_PTP_V2_DELAY_REQ,
+};
+
+struct sfxge_hwtstamp_config {
+	uint32_t drv_version;
+	uint32_t flags;
+	uint32_t tx_type;
+	uint32_t rx_filter;
+};
+
+/* Read any transmit or receive timestamps since the last call **************/
+
+struct sfxge_ts_read {
+	uint32_t tx_valid;
+	struct sfxge_timespec tx_ts;
+	struct sfxge_timespec tx_ts_hw;
+	uint32_t rx_valid;
+	struct sfxge_timespec rx_ts;
+	struct sfxge_timespec rx_ts_hw;
+	uint8_t uuid [6];
+	uint8_t seqid [2];
+};
+
+struct sfxge_ts_settime {
+        struct sfxge_timespec ts; /* In and out */
+        uint32_t iswrite;          /* 1 == write, 0 == read (only) */
+};
+
+struct sfxge_ts_adjtime {
+        int64_t adjustment;       /* Parts per billion, In and out */
+        uint32_t iswrite;          /* 1 == write, 0 == read (only) */
+};
+
+struct sfxge_ts_sync {
+        struct sfxge_timespec ts;
+};
+
+union sfxge_ioctl_data {
+	struct sfxge_hwtstamp_config ts_init;
+	struct sfxge_ts_read ts_read;
+	struct sfxge_ts_settime ts_settime;
+	struct sfxge_ts_adjtime ts_adjtime;
+	struct sfxge_ts_sync ts_sync;
+};
+
+struct sfxge_sock_ioctl {
+	uint32_t cmd;
+	uint16_t reserved;
+	union sfxge_ioctl_data u;
+};
+#endif /* SFXGE_IOCTL_H */
+
+
